diff --git a/src/backend/snowball/libstemmer/stem_UTF_8_turkish.c b/src/backend/snowball/libstemmer/stem_UTF_8_turkish.c
index 587351d126..85eee41ada 100644
--- a/src/backend/snowball/libstemmer/stem_UTF_8_turkish.c
+++ b/src/backend/snowball/libstemmer/stem_UTF_8_turkish.c
@@ -438,575 +438,495 @@ static const unsigned char g_vowel5[] = { 65 };
 
 static const unsigned char g_vowel6[] = { 65 };
 
-static const symbol s_0[] = { 'a' };
-static const symbol s_1[] = { 'e' };
-static const symbol s_2[] = { 0xC4, 0xB1 };
-static const symbol s_3[] = { 'i' };
-static const symbol s_4[] = { 'o' };
-static const symbol s_5[] = { 0xC3, 0xB6 };
-static const symbol s_6[] = { 'u' };
-static const symbol s_7[] = { 0xC3, 0xBC };
-static const symbol s_8[] = { 'n' };
-static const symbol s_9[] = { 'n' };
-static const symbol s_10[] = { 's' };
-static const symbol s_11[] = { 's' };
-static const symbol s_12[] = { 'y' };
-static const symbol s_13[] = { 'y' };
-static const symbol s_14[] = { 'k', 'i' };
-static const symbol s_15[] = { 'k', 'e', 'n' };
-static const symbol s_16[] = { 'p' };
-static const symbol s_17[] = { 0xC3, 0xA7 };
-static const symbol s_18[] = { 't' };
-static const symbol s_19[] = { 'k' };
-static const symbol s_20[] = { 'd' };
-static const symbol s_21[] = { 'g' };
-static const symbol s_22[] = { 'a' };
-static const symbol s_23[] = { 0xC4, 0xB1 };
-static const symbol s_24[] = { 0xC4, 0xB1 };
-static const symbol s_25[] = { 'e' };
-static const symbol s_26[] = { 'i' };
-static const symbol s_27[] = { 'i' };
-static const symbol s_28[] = { 'o' };
-static const symbol s_29[] = { 'u' };
-static const symbol s_30[] = { 'u' };
-static const symbol s_31[] = { 0xC3, 0xB6 };
-static const symbol s_32[] = { 0xC3, 0xBC };
-static const symbol s_33[] = { 0xC3, 0xBC };
-static const symbol s_34[] = { 'a', 'd' };
-static const symbol s_35[] = { 's', 'o', 'y', 'a', 'd' };
+static const symbol s_0[] = { 0xC4, 0xB1 };
+static const symbol s_1[] = { 0xC3, 0xB6 };
+static const symbol s_2[] = { 0xC3, 0xBC };
+static const symbol s_3[] = { 'k', 'i' };
+static const symbol s_4[] = { 'k', 'e', 'n' };
+static const symbol s_5[] = { 'p' };
+static const symbol s_6[] = { 0xC3, 0xA7 };
+static const symbol s_7[] = { 't' };
+static const symbol s_8[] = { 'k' };
+static const symbol s_9[] = { 0xC4, 0xB1 };
+static const symbol s_10[] = { 0xC4, 0xB1 };
+static const symbol s_11[] = { 'i' };
+static const symbol s_12[] = { 'u' };
+static const symbol s_13[] = { 0xC3, 0xB6 };
+static const symbol s_14[] = { 0xC3, 0xBC };
+static const symbol s_15[] = { 0xC3, 0xBC };
+static const symbol s_16[] = { 'a', 'd' };
+static const symbol s_17[] = { 's', 'o', 'y' };
 
-static int r_check_vowel_harmony(struct SN_env * z) {
-    {   int m_test = z->l - z->c; /* test, line 112 */
-        if (out_grouping_b_U(z, g_vowel, 97, 305, 1) < 0) return 0; /* goto */ /* grouping vowel, line 114 */
-        {   int m1 = z->l - z->c; (void)m1; /* or, line 116 */
-            if (!(eq_s_b(z, 1, s_0))) goto lab1;
-            if (out_grouping_b_U(z, g_vowel1, 97, 305, 1) < 0) goto lab1; /* goto */ /* grouping vowel1, line 116 */
+static int r_check_vowel_harmony(struct SN_env * z) { /* backwardmode */
+    {   int m_test1 = z->l - z->c; /* test, line 110 */
+        if (out_grouping_b_U(z, g_vowel, 97, 305, 1) < 0) return 0; /* goto */ /* grouping vowel, line 112 */
+        {   int m2 = z->l - z->c; (void)m2; /* or, line 114 */
+            if (z->c <= z->lb || z->p[z->c - 1] != 'a') goto lab1; /* literal, line 114 */
+            z->c--;
+            if (out_grouping_b_U(z, g_vowel1, 97, 305, 1) < 0) goto lab1; /* goto */ /* grouping vowel1, line 114 */
             goto lab0;
         lab1:
-            z->c = z->l - m1;
-            if (!(eq_s_b(z, 1, s_1))) goto lab2;
-            if (out_grouping_b_U(z, g_vowel2, 101, 252, 1) < 0) goto lab2; /* goto */ /* grouping vowel2, line 117 */
+            z->c = z->l - m2;
+            if (z->c <= z->lb || z->p[z->c - 1] != 'e') goto lab2; /* literal, line 115 */
+            z->c--;
+            if (out_grouping_b_U(z, g_vowel2, 101, 252, 1) < 0) goto lab2; /* goto */ /* grouping vowel2, line 115 */
             goto lab0;
         lab2:
-            z->c = z->l - m1;
-            if (!(eq_s_b(z, 2, s_2))) goto lab3;
-            if (out_grouping_b_U(z, g_vowel3, 97, 305, 1) < 0) goto lab3; /* goto */ /* grouping vowel3, line 118 */
+            z->c = z->l - m2;
+            if (!(eq_s_b(z, 2, s_0))) goto lab3; /* literal, line 116 */
+            if (out_grouping_b_U(z, g_vowel3, 97, 305, 1) < 0) goto lab3; /* goto */ /* grouping vowel3, line 116 */
             goto lab0;
         lab3:
-            z->c = z->l - m1;
-            if (!(eq_s_b(z, 1, s_3))) goto lab4;
-            if (out_grouping_b_U(z, g_vowel4, 101, 105, 1) < 0) goto lab4; /* goto */ /* grouping vowel4, line 119 */
+            z->c = z->l - m2;
+            if (z->c <= z->lb || z->p[z->c - 1] != 'i') goto lab4; /* literal, line 117 */
+            z->c--;
+            if (out_grouping_b_U(z, g_vowel4, 101, 105, 1) < 0) goto lab4; /* goto */ /* grouping vowel4, line 117 */
             goto lab0;
         lab4:
-            z->c = z->l - m1;
-            if (!(eq_s_b(z, 1, s_4))) goto lab5;
-            if (out_grouping_b_U(z, g_vowel5, 111, 117, 1) < 0) goto lab5; /* goto */ /* grouping vowel5, line 120 */
+            z->c = z->l - m2;
+            if (z->c <= z->lb || z->p[z->c - 1] != 'o') goto lab5; /* literal, line 118 */
+            z->c--;
+            if (out_grouping_b_U(z, g_vowel5, 111, 117, 1) < 0) goto lab5; /* goto */ /* grouping vowel5, line 118 */
             goto lab0;
         lab5:
-            z->c = z->l - m1;
-            if (!(eq_s_b(z, 2, s_5))) goto lab6;
-            if (out_grouping_b_U(z, g_vowel6, 246, 252, 1) < 0) goto lab6; /* goto */ /* grouping vowel6, line 121 */
+            z->c = z->l - m2;
+            if (!(eq_s_b(z, 2, s_1))) goto lab6; /* literal, line 119 */
+            if (out_grouping_b_U(z, g_vowel6, 246, 252, 1) < 0) goto lab6; /* goto */ /* grouping vowel6, line 119 */
             goto lab0;
         lab6:
-            z->c = z->l - m1;
-            if (!(eq_s_b(z, 1, s_6))) goto lab7;
-            if (out_grouping_b_U(z, g_vowel5, 111, 117, 1) < 0) goto lab7; /* goto */ /* grouping vowel5, line 122 */
+            z->c = z->l - m2;
+            if (z->c <= z->lb || z->p[z->c - 1] != 'u') goto lab7; /* literal, line 120 */
+            z->c--;
+            if (out_grouping_b_U(z, g_vowel5, 111, 117, 1) < 0) goto lab7; /* goto */ /* grouping vowel5, line 120 */
             goto lab0;
         lab7:
-            z->c = z->l - m1;
-            if (!(eq_s_b(z, 2, s_7))) return 0;
-            if (out_grouping_b_U(z, g_vowel6, 246, 252, 1) < 0) return 0; /* goto */ /* grouping vowel6, line 123 */
+            z->c = z->l - m2;
+            if (!(eq_s_b(z, 2, s_2))) return 0; /* literal, line 121 */
+            if (out_grouping_b_U(z, g_vowel6, 246, 252, 1) < 0) return 0; /* goto */ /* grouping vowel6, line 121 */
         }
     lab0:
-        z->c = z->l - m_test;
+        z->c = z->l - m_test1;
     }
     return 1;
 }
 
-static int r_mark_suffix_with_optional_n_consonant(struct SN_env * z) {
-    {   int m1 = z->l - z->c; (void)m1; /* or, line 134 */
-        {   int m_test = z->l - z->c; /* test, line 133 */
-            if (!(eq_s_b(z, 1, s_8))) goto lab1;
-            z->c = z->l - m_test;
-        }
-        {   int ret = skip_utf8(z->p, z->c, z->lb, 0, -1);
-            if (ret < 0) goto lab1;
-            z->c = ret; /* next, line 133 */
-        }
-        {   int m_test = z->l - z->c; /* test, line 133 */
-            if (in_grouping_b_U(z, g_vowel, 97, 305, 0)) goto lab1;
-            z->c = z->l - m_test;
+static int r_mark_suffix_with_optional_n_consonant(struct SN_env * z) { /* backwardmode */
+    {   int m1 = z->l - z->c; (void)m1; /* or, line 132 */
+        if (z->c <= z->lb || z->p[z->c - 1] != 'n') goto lab1; /* literal, line 131 */
+        z->c--;
+        {   int m_test2 = z->l - z->c; /* test, line 131 */
+            if (in_grouping_b_U(z, g_vowel, 97, 305, 0)) goto lab1; /* grouping vowel, line 131 */
+            z->c = z->l - m_test2;
         }
         goto lab0;
     lab1:
         z->c = z->l - m1;
-        {   int m2 = z->l - z->c; (void)m2; /* not, line 135 */
-            {   int m_test = z->l - z->c; /* test, line 135 */
-                if (!(eq_s_b(z, 1, s_9))) goto lab2;
-                z->c = z->l - m_test;
+        {   int m3 = z->l - z->c; (void)m3; /* not, line 133 */
+            {   int m_test4 = z->l - z->c; /* test, line 133 */
+                if (z->c <= z->lb || z->p[z->c - 1] != 'n') goto lab2; /* literal, line 133 */
+                z->c--;
+                z->c = z->l - m_test4;
             }
             return 0;
         lab2:
-            z->c = z->l - m2;
+            z->c = z->l - m3;
         }
-        {   int m_test = z->l - z->c; /* test, line 135 */
+        {   int m_test5 = z->l - z->c; /* test, line 133 */
             {   int ret = skip_utf8(z->p, z->c, z->lb, 0, -1);
                 if (ret < 0) return 0;
-                z->c = ret; /* next, line 135 */
-            }
-            {   int m_test = z->l - z->c; /* test, line 135 */
-                if (in_grouping_b_U(z, g_vowel, 97, 305, 0)) return 0;
-                z->c = z->l - m_test;
+                z->c = ret; /* next, line 133 */
             }
-            z->c = z->l - m_test;
+            if (in_grouping_b_U(z, g_vowel, 97, 305, 0)) return 0; /* grouping vowel, line 133 */
+            z->c = z->l - m_test5;
         }
     }
 lab0:
     return 1;
 }
 
-static int r_mark_suffix_with_optional_s_consonant(struct SN_env * z) {
-    {   int m1 = z->l - z->c; (void)m1; /* or, line 145 */
-        {   int m_test = z->l - z->c; /* test, line 144 */
-            if (!(eq_s_b(z, 1, s_10))) goto lab1;
-            z->c = z->l - m_test;
-        }
-        {   int ret = skip_utf8(z->p, z->c, z->lb, 0, -1);
-            if (ret < 0) goto lab1;
-            z->c = ret; /* next, line 144 */
-        }
-        {   int m_test = z->l - z->c; /* test, line 144 */
-            if (in_grouping_b_U(z, g_vowel, 97, 305, 0)) goto lab1;
-            z->c = z->l - m_test;
+static int r_mark_suffix_with_optional_s_consonant(struct SN_env * z) { /* backwardmode */
+    {   int m1 = z->l - z->c; (void)m1; /* or, line 143 */
+        if (z->c <= z->lb || z->p[z->c - 1] != 's') goto lab1; /* literal, line 142 */
+        z->c--;
+        {   int m_test2 = z->l - z->c; /* test, line 142 */
+            if (in_grouping_b_U(z, g_vowel, 97, 305, 0)) goto lab1; /* grouping vowel, line 142 */
+            z->c = z->l - m_test2;
         }
         goto lab0;
     lab1:
         z->c = z->l - m1;
-        {   int m2 = z->l - z->c; (void)m2; /* not, line 146 */
-            {   int m_test = z->l - z->c; /* test, line 146 */
-                if (!(eq_s_b(z, 1, s_11))) goto lab2;
-                z->c = z->l - m_test;
+        {   int m3 = z->l - z->c; (void)m3; /* not, line 144 */
+            {   int m_test4 = z->l - z->c; /* test, line 144 */
+                if (z->c <= z->lb || z->p[z->c - 1] != 's') goto lab2; /* literal, line 144 */
+                z->c--;
+                z->c = z->l - m_test4;
             }
             return 0;
         lab2:
-            z->c = z->l - m2;
+            z->c = z->l - m3;
         }
-        {   int m_test = z->l - z->c; /* test, line 146 */
+        {   int m_test5 = z->l - z->c; /* test, line 144 */
             {   int ret = skip_utf8(z->p, z->c, z->lb, 0, -1);
                 if (ret < 0) return 0;
-                z->c = ret; /* next, line 146 */
-            }
-            {   int m_test = z->l - z->c; /* test, line 146 */
-                if (in_grouping_b_U(z, g_vowel, 97, 305, 0)) return 0;
-                z->c = z->l - m_test;
+                z->c = ret; /* next, line 144 */
             }
-            z->c = z->l - m_test;
+            if (in_grouping_b_U(z, g_vowel, 97, 305, 0)) return 0; /* grouping vowel, line 144 */
+            z->c = z->l - m_test5;
         }
     }
 lab0:
     return 1;
 }
 
-static int r_mark_suffix_with_optional_y_consonant(struct SN_env * z) {
-    {   int m1 = z->l - z->c; (void)m1; /* or, line 155 */
-        {   int m_test = z->l - z->c; /* test, line 154 */
-            if (!(eq_s_b(z, 1, s_12))) goto lab1;
-            z->c = z->l - m_test;
-        }
-        {   int ret = skip_utf8(z->p, z->c, z->lb, 0, -1);
-            if (ret < 0) goto lab1;
-            z->c = ret; /* next, line 154 */
-        }
-        {   int m_test = z->l - z->c; /* test, line 154 */
-            if (in_grouping_b_U(z, g_vowel, 97, 305, 0)) goto lab1;
-            z->c = z->l - m_test;
+static int r_mark_suffix_with_optional_y_consonant(struct SN_env * z) { /* backwardmode */
+    {   int m1 = z->l - z->c; (void)m1; /* or, line 153 */
+        if (z->c <= z->lb || z->p[z->c - 1] != 'y') goto lab1; /* literal, line 152 */
+        z->c--;
+        {   int m_test2 = z->l - z->c; /* test, line 152 */
+            if (in_grouping_b_U(z, g_vowel, 97, 305, 0)) goto lab1; /* grouping vowel, line 152 */
+            z->c = z->l - m_test2;
         }
         goto lab0;
     lab1:
         z->c = z->l - m1;
-        {   int m2 = z->l - z->c; (void)m2; /* not, line 156 */
-            {   int m_test = z->l - z->c; /* test, line 156 */
-                if (!(eq_s_b(z, 1, s_13))) goto lab2;
-                z->c = z->l - m_test;
+        {   int m3 = z->l - z->c; (void)m3; /* not, line 154 */
+            {   int m_test4 = z->l - z->c; /* test, line 154 */
+                if (z->c <= z->lb || z->p[z->c - 1] != 'y') goto lab2; /* literal, line 154 */
+                z->c--;
+                z->c = z->l - m_test4;
             }
             return 0;
         lab2:
-            z->c = z->l - m2;
+            z->c = z->l - m3;
         }
-        {   int m_test = z->l - z->c; /* test, line 156 */
+        {   int m_test5 = z->l - z->c; /* test, line 154 */
             {   int ret = skip_utf8(z->p, z->c, z->lb, 0, -1);
                 if (ret < 0) return 0;
-                z->c = ret; /* next, line 156 */
-            }
-            {   int m_test = z->l - z->c; /* test, line 156 */
-                if (in_grouping_b_U(z, g_vowel, 97, 305, 0)) return 0;
-                z->c = z->l - m_test;
+                z->c = ret; /* next, line 154 */
             }
-            z->c = z->l - m_test;
+            if (in_grouping_b_U(z, g_vowel, 97, 305, 0)) return 0; /* grouping vowel, line 154 */
+            z->c = z->l - m_test5;
         }
     }
 lab0:
     return 1;
 }
 
-static int r_mark_suffix_with_optional_U_vowel(struct SN_env * z) {
-    {   int m1 = z->l - z->c; (void)m1; /* or, line 161 */
-        {   int m_test = z->l - z->c; /* test, line 160 */
-            if (in_grouping_b_U(z, g_U, 105, 305, 0)) goto lab1;
-            z->c = z->l - m_test;
-        }
-        {   int ret = skip_utf8(z->p, z->c, z->lb, 0, -1);
-            if (ret < 0) goto lab1;
-            z->c = ret; /* next, line 160 */
-        }
-        {   int m_test = z->l - z->c; /* test, line 160 */
-            if (out_grouping_b_U(z, g_vowel, 97, 305, 0)) goto lab1;
-            z->c = z->l - m_test;
+static int r_mark_suffix_with_optional_U_vowel(struct SN_env * z) { /* backwardmode */
+    {   int m1 = z->l - z->c; (void)m1; /* or, line 159 */
+        if (in_grouping_b_U(z, g_U, 105, 305, 0)) goto lab1; /* grouping U, line 158 */
+        {   int m_test2 = z->l - z->c; /* test, line 158 */
+            if (out_grouping_b_U(z, g_vowel, 97, 305, 0)) goto lab1; /* non vowel, line 158 */
+            z->c = z->l - m_test2;
         }
         goto lab0;
     lab1:
         z->c = z->l - m1;
-        {   int m2 = z->l - z->c; (void)m2; /* not, line 162 */
-            {   int m_test = z->l - z->c; /* test, line 162 */
-                if (in_grouping_b_U(z, g_U, 105, 305, 0)) goto lab2;
-                z->c = z->l - m_test;
+        {   int m3 = z->l - z->c; (void)m3; /* not, line 160 */
+            {   int m_test4 = z->l - z->c; /* test, line 160 */
+                if (in_grouping_b_U(z, g_U, 105, 305, 0)) goto lab2; /* grouping U, line 160 */
+                z->c = z->l - m_test4;
             }
             return 0;
         lab2:
-            z->c = z->l - m2;
+            z->c = z->l - m3;
         }
-        {   int m_test = z->l - z->c; /* test, line 162 */
+        {   int m_test5 = z->l - z->c; /* test, line 160 */
             {   int ret = skip_utf8(z->p, z->c, z->lb, 0, -1);
                 if (ret < 0) return 0;
-                z->c = ret; /* next, line 162 */
-            }
-            {   int m_test = z->l - z->c; /* test, line 162 */
-                if (out_grouping_b_U(z, g_vowel, 97, 305, 0)) return 0;
-                z->c = z->l - m_test;
+                z->c = ret; /* next, line 160 */
             }
-            z->c = z->l - m_test;
+            if (out_grouping_b_U(z, g_vowel, 97, 305, 0)) return 0; /* non vowel, line 160 */
+            z->c = z->l - m_test5;
         }
     }
 lab0:
     return 1;
 }
 
-static int r_mark_possessives(struct SN_env * z) {
-    if (z->c <= z->lb || z->p[z->c - 1] >> 5 != 3 || !((67133440 >> (z->p[z->c - 1] & 0x1f)) & 1)) return 0;
-    if (!(find_among_b(z, a_0, 10))) return 0; /* among, line 167 */
-    {   int ret = r_mark_suffix_with_optional_U_vowel(z);
-        if (ret == 0) return 0; /* call mark_suffix_with_optional_U_vowel, line 169 */
-        if (ret < 0) return ret;
+static int r_mark_possessives(struct SN_env * z) { /* backwardmode */
+    if (z->c <= z->lb || z->p[z->c - 1] >> 5 != 3 || !((67133440 >> (z->p[z->c - 1] & 0x1f)) & 1)) return 0; /* among, line 165 */
+    if (!(find_among_b(z, a_0, 10))) return 0;
+    {   int ret = r_mark_suffix_with_optional_U_vowel(z); /* call mark_suffix_with_optional_U_vowel, line 167 */
+        if (ret <= 0) return ret;
     }
     return 1;
 }
 
-static int r_mark_sU(struct SN_env * z) {
-    {   int ret = r_check_vowel_harmony(z);
-        if (ret == 0) return 0; /* call check_vowel_harmony, line 173 */
-        if (ret < 0) return ret;
+static int r_mark_sU(struct SN_env * z) { /* backwardmode */
+    {   int ret = r_check_vowel_harmony(z); /* call check_vowel_harmony, line 171 */
+        if (ret <= 0) return ret;
     }
-    if (in_grouping_b_U(z, g_U, 105, 305, 0)) return 0;
-    {   int ret = r_mark_suffix_with_optional_s_consonant(z);
-        if (ret == 0) return 0; /* call mark_suffix_with_optional_s_consonant, line 175 */
-        if (ret < 0) return ret;
+    if (in_grouping_b_U(z, g_U, 105, 305, 0)) return 0; /* grouping U, line 172 */
+    {   int ret = r_mark_suffix_with_optional_s_consonant(z); /* call mark_suffix_with_optional_s_consonant, line 173 */
+        if (ret <= 0) return ret;
     }
     return 1;
 }
 
-static int r_mark_lArI(struct SN_env * z) {
-    if (z->c - 3 <= z->lb || (z->p[z->c - 1] != 105 && z->p[z->c - 1] != 177)) return 0;
-    if (!(find_among_b(z, a_1, 2))) return 0; /* among, line 179 */
+static int r_mark_lArI(struct SN_env * z) { /* backwardmode */
+    if (z->c - 3 <= z->lb || (z->p[z->c - 1] != 105 && z->p[z->c - 1] != 177)) return 0; /* among, line 177 */
+    if (!(find_among_b(z, a_1, 2))) return 0;
     return 1;
 }
 
-static int r_mark_yU(struct SN_env * z) {
-    {   int ret = r_check_vowel_harmony(z);
-        if (ret == 0) return 0; /* call check_vowel_harmony, line 183 */
-        if (ret < 0) return ret;
+static int r_mark_yU(struct SN_env * z) { /* backwardmode */
+    {   int ret = r_check_vowel_harmony(z); /* call check_vowel_harmony, line 181 */
+        if (ret <= 0) return ret;
     }
-    if (in_grouping_b_U(z, g_U, 105, 305, 0)) return 0;
-    {   int ret = r_mark_suffix_with_optional_y_consonant(z);
-        if (ret == 0) return 0; /* call mark_suffix_with_optional_y_consonant, line 185 */
-        if (ret < 0) return ret;
+    if (in_grouping_b_U(z, g_U, 105, 305, 0)) return 0; /* grouping U, line 182 */
+    {   int ret = r_mark_suffix_with_optional_y_consonant(z); /* call mark_suffix_with_optional_y_consonant, line 183 */
+        if (ret <= 0) return ret;
     }
     return 1;
 }
 
-static int r_mark_nU(struct SN_env * z) {
-    {   int ret = r_check_vowel_harmony(z);
-        if (ret == 0) return 0; /* call check_vowel_harmony, line 189 */
-        if (ret < 0) return ret;
+static int r_mark_nU(struct SN_env * z) { /* backwardmode */
+    {   int ret = r_check_vowel_harmony(z); /* call check_vowel_harmony, line 187 */
+        if (ret <= 0) return ret;
     }
-    if (!(find_among_b(z, a_2, 4))) return 0; /* among, line 190 */
+    if (!(find_among_b(z, a_2, 4))) return 0; /* among, line 188 */
     return 1;
 }
 
-static int r_mark_nUn(struct SN_env * z) {
-    {   int ret = r_check_vowel_harmony(z);
-        if (ret == 0) return 0; /* call check_vowel_harmony, line 194 */
-        if (ret < 0) return ret;
+static int r_mark_nUn(struct SN_env * z) { /* backwardmode */
+    {   int ret = r_check_vowel_harmony(z); /* call check_vowel_harmony, line 192 */
+        if (ret <= 0) return ret;
     }
-    if (z->c - 1 <= z->lb || z->p[z->c - 1] != 110) return 0;
-    if (!(find_among_b(z, a_3, 4))) return 0; /* among, line 195 */
-    {   int ret = r_mark_suffix_with_optional_n_consonant(z);
-        if (ret == 0) return 0; /* call mark_suffix_with_optional_n_consonant, line 196 */
-        if (ret < 0) return ret;
+    if (z->c - 1 <= z->lb || z->p[z->c - 1] != 110) return 0; /* among, line 193 */
+    if (!(find_among_b(z, a_3, 4))) return 0;
+    {   int ret = r_mark_suffix_with_optional_n_consonant(z); /* call mark_suffix_with_optional_n_consonant, line 194 */
+        if (ret <= 0) return ret;
     }
     return 1;
 }
 
-static int r_mark_yA(struct SN_env * z) {
-    {   int ret = r_check_vowel_harmony(z);
-        if (ret == 0) return 0; /* call check_vowel_harmony, line 200 */
-        if (ret < 0) return ret;
+static int r_mark_yA(struct SN_env * z) { /* backwardmode */
+    {   int ret = r_check_vowel_harmony(z); /* call check_vowel_harmony, line 198 */
+        if (ret <= 0) return ret;
     }
-    if (z->c <= z->lb || (z->p[z->c - 1] != 97 && z->p[z->c - 1] != 101)) return 0;
-    if (!(find_among_b(z, a_4, 2))) return 0; /* among, line 201 */
-    {   int ret = r_mark_suffix_with_optional_y_consonant(z);
-        if (ret == 0) return 0; /* call mark_suffix_with_optional_y_consonant, line 202 */
-        if (ret < 0) return ret;
+    if (z->c <= z->lb || (z->p[z->c - 1] != 97 && z->p[z->c - 1] != 101)) return 0; /* among, line 199 */
+    if (!(find_among_b(z, a_4, 2))) return 0;
+    {   int ret = r_mark_suffix_with_optional_y_consonant(z); /* call mark_suffix_with_optional_y_consonant, line 200 */
+        if (ret <= 0) return ret;
     }
     return 1;
 }
 
-static int r_mark_nA(struct SN_env * z) {
-    {   int ret = r_check_vowel_harmony(z);
-        if (ret == 0) return 0; /* call check_vowel_harmony, line 206 */
-        if (ret < 0) return ret;
+static int r_mark_nA(struct SN_env * z) { /* backwardmode */
+    {   int ret = r_check_vowel_harmony(z); /* call check_vowel_harmony, line 204 */
+        if (ret <= 0) return ret;
     }
-    if (z->c - 1 <= z->lb || (z->p[z->c - 1] != 97 && z->p[z->c - 1] != 101)) return 0;
-    if (!(find_among_b(z, a_5, 2))) return 0; /* among, line 207 */
+    if (z->c - 1 <= z->lb || (z->p[z->c - 1] != 97 && z->p[z->c - 1] != 101)) return 0; /* among, line 205 */
+    if (!(find_among_b(z, a_5, 2))) return 0;
     return 1;
 }
 
-static int r_mark_DA(struct SN_env * z) {
-    {   int ret = r_check_vowel_harmony(z);
-        if (ret == 0) return 0; /* call check_vowel_harmony, line 211 */
-        if (ret < 0) return ret;
+static int r_mark_DA(struct SN_env * z) { /* backwardmode */
+    {   int ret = r_check_vowel_harmony(z); /* call check_vowel_harmony, line 209 */
+        if (ret <= 0) return ret;
     }
-    if (z->c - 1 <= z->lb || (z->p[z->c - 1] != 97 && z->p[z->c - 1] != 101)) return 0;
-    if (!(find_among_b(z, a_6, 4))) return 0; /* among, line 212 */
+    if (z->c - 1 <= z->lb || (z->p[z->c - 1] != 97 && z->p[z->c - 1] != 101)) return 0; /* among, line 210 */
+    if (!(find_among_b(z, a_6, 4))) return 0;
     return 1;
 }
 
-static int r_mark_ndA(struct SN_env * z) {
-    {   int ret = r_check_vowel_harmony(z);
-        if (ret == 0) return 0; /* call check_vowel_harmony, line 216 */
-        if (ret < 0) return ret;
+static int r_mark_ndA(struct SN_env * z) { /* backwardmode */
+    {   int ret = r_check_vowel_harmony(z); /* call check_vowel_harmony, line 214 */
+        if (ret <= 0) return ret;
     }
-    if (z->c - 2 <= z->lb || (z->p[z->c - 1] != 97 && z->p[z->c - 1] != 101)) return 0;
-    if (!(find_among_b(z, a_7, 2))) return 0; /* among, line 217 */
+    if (z->c - 2 <= z->lb || (z->p[z->c - 1] != 97 && z->p[z->c - 1] != 101)) return 0; /* among, line 215 */
+    if (!(find_among_b(z, a_7, 2))) return 0;
     return 1;
 }
 
-static int r_mark_DAn(struct SN_env * z) {
-    {   int ret = r_check_vowel_harmony(z);
-        if (ret == 0) return 0; /* call check_vowel_harmony, line 221 */
-        if (ret < 0) return ret;
+static int r_mark_DAn(struct SN_env * z) { /* backwardmode */
+    {   int ret = r_check_vowel_harmony(z); /* call check_vowel_harmony, line 219 */
+        if (ret <= 0) return ret;
     }
-    if (z->c - 2 <= z->lb || z->p[z->c - 1] != 110) return 0;
-    if (!(find_among_b(z, a_8, 4))) return 0; /* among, line 222 */
+    if (z->c - 2 <= z->lb || z->p[z->c - 1] != 110) return 0; /* among, line 220 */
+    if (!(find_among_b(z, a_8, 4))) return 0;
     return 1;
 }
 
-static int r_mark_ndAn(struct SN_env * z) {
-    {   int ret = r_check_vowel_harmony(z);
-        if (ret == 0) return 0; /* call check_vowel_harmony, line 226 */
-        if (ret < 0) return ret;
+static int r_mark_ndAn(struct SN_env * z) { /* backwardmode */
+    {   int ret = r_check_vowel_harmony(z); /* call check_vowel_harmony, line 224 */
+        if (ret <= 0) return ret;
     }
-    if (z->c - 3 <= z->lb || z->p[z->c - 1] != 110) return 0;
-    if (!(find_among_b(z, a_9, 2))) return 0; /* among, line 227 */
+    if (z->c - 3 <= z->lb || z->p[z->c - 1] != 110) return 0; /* among, line 225 */
+    if (!(find_among_b(z, a_9, 2))) return 0;
     return 1;
 }
 
-static int r_mark_ylA(struct SN_env * z) {
-    {   int ret = r_check_vowel_harmony(z);
-        if (ret == 0) return 0; /* call check_vowel_harmony, line 231 */
-        if (ret < 0) return ret;
+static int r_mark_ylA(struct SN_env * z) { /* backwardmode */
+    {   int ret = r_check_vowel_harmony(z); /* call check_vowel_harmony, line 229 */
+        if (ret <= 0) return ret;
     }
-    if (z->c - 1 <= z->lb || (z->p[z->c - 1] != 97 && z->p[z->c - 1] != 101)) return 0;
-    if (!(find_among_b(z, a_10, 2))) return 0; /* among, line 232 */
-    {   int ret = r_mark_suffix_with_optional_y_consonant(z);
-        if (ret == 0) return 0; /* call mark_suffix_with_optional_y_consonant, line 233 */
-        if (ret < 0) return ret;
+    if (z->c - 1 <= z->lb || (z->p[z->c - 1] != 97 && z->p[z->c - 1] != 101)) return 0; /* among, line 230 */
+    if (!(find_among_b(z, a_10, 2))) return 0;
+    {   int ret = r_mark_suffix_with_optional_y_consonant(z); /* call mark_suffix_with_optional_y_consonant, line 231 */
+        if (ret <= 0) return ret;
     }
     return 1;
 }
 
-static int r_mark_ki(struct SN_env * z) {
-    if (!(eq_s_b(z, 2, s_14))) return 0;
+static int r_mark_ki(struct SN_env * z) { /* backwardmode */
+    if (!(eq_s_b(z, 2, s_3))) return 0; /* literal, line 235 */
     return 1;
 }
 
-static int r_mark_ncA(struct SN_env * z) {
-    {   int ret = r_check_vowel_harmony(z);
-        if (ret == 0) return 0; /* call check_vowel_harmony, line 241 */
-        if (ret < 0) return ret;
+static int r_mark_ncA(struct SN_env * z) { /* backwardmode */
+    {   int ret = r_check_vowel_harmony(z); /* call check_vowel_harmony, line 239 */
+        if (ret <= 0) return ret;
     }
-    if (z->c - 1 <= z->lb || (z->p[z->c - 1] != 97 && z->p[z->c - 1] != 101)) return 0;
-    if (!(find_among_b(z, a_11, 2))) return 0; /* among, line 242 */
-    {   int ret = r_mark_suffix_with_optional_n_consonant(z);
-        if (ret == 0) return 0; /* call mark_suffix_with_optional_n_consonant, line 243 */
-        if (ret < 0) return ret;
+    if (z->c - 1 <= z->lb || (z->p[z->c - 1] != 97 && z->p[z->c - 1] != 101)) return 0; /* among, line 240 */
+    if (!(find_among_b(z, a_11, 2))) return 0;
+    {   int ret = r_mark_suffix_with_optional_n_consonant(z); /* call mark_suffix_with_optional_n_consonant, line 241 */
+        if (ret <= 0) return ret;
     }
     return 1;
 }
 
-static int r_mark_yUm(struct SN_env * z) {
-    {   int ret = r_check_vowel_harmony(z);
-        if (ret == 0) return 0; /* call check_vowel_harmony, line 247 */
-        if (ret < 0) return ret;
+static int r_mark_yUm(struct SN_env * z) { /* backwardmode */
+    {   int ret = r_check_vowel_harmony(z); /* call check_vowel_harmony, line 245 */
+        if (ret <= 0) return ret;
     }
-    if (z->c - 1 <= z->lb || z->p[z->c - 1] != 109) return 0;
-    if (!(find_among_b(z, a_12, 4))) return 0; /* among, line 248 */
-    {   int ret = r_mark_suffix_with_optional_y_consonant(z);
-        if (ret == 0) return 0; /* call mark_suffix_with_optional_y_consonant, line 249 */
-        if (ret < 0) return ret;
+    if (z->c - 1 <= z->lb || z->p[z->c - 1] != 109) return 0; /* among, line 246 */
+    if (!(find_among_b(z, a_12, 4))) return 0;
+    {   int ret = r_mark_suffix_with_optional_y_consonant(z); /* call mark_suffix_with_optional_y_consonant, line 247 */
+        if (ret <= 0) return ret;
     }
     return 1;
 }
 
-static int r_mark_sUn(struct SN_env * z) {
-    {   int ret = r_check_vowel_harmony(z);
-        if (ret == 0) return 0; /* call check_vowel_harmony, line 253 */
-        if (ret < 0) return ret;
+static int r_mark_sUn(struct SN_env * z) { /* backwardmode */
+    {   int ret = r_check_vowel_harmony(z); /* call check_vowel_harmony, line 251 */
+        if (ret <= 0) return ret;
     }
-    if (z->c - 2 <= z->lb || z->p[z->c - 1] != 110) return 0;
-    if (!(find_among_b(z, a_13, 4))) return 0; /* among, line 254 */
+    if (z->c - 2 <= z->lb || z->p[z->c - 1] != 110) return 0; /* among, line 252 */
+    if (!(find_among_b(z, a_13, 4))) return 0;
     return 1;
 }
 
-static int r_mark_yUz(struct SN_env * z) {
-    {   int ret = r_check_vowel_harmony(z);
-        if (ret == 0) return 0; /* call check_vowel_harmony, line 258 */
-        if (ret < 0) return ret;
+static int r_mark_yUz(struct SN_env * z) { /* backwardmode */
+    {   int ret = r_check_vowel_harmony(z); /* call check_vowel_harmony, line 256 */
+        if (ret <= 0) return ret;
     }
-    if (z->c - 1 <= z->lb || z->p[z->c - 1] != 122) return 0;
-    if (!(find_among_b(z, a_14, 4))) return 0; /* among, line 259 */
-    {   int ret = r_mark_suffix_with_optional_y_consonant(z);
-        if (ret == 0) return 0; /* call mark_suffix_with_optional_y_consonant, line 260 */
-        if (ret < 0) return ret;
+    if (z->c - 1 <= z->lb || z->p[z->c - 1] != 122) return 0; /* among, line 257 */
+    if (!(find_among_b(z, a_14, 4))) return 0;
+    {   int ret = r_mark_suffix_with_optional_y_consonant(z); /* call mark_suffix_with_optional_y_consonant, line 258 */
+        if (ret <= 0) return ret;
     }
     return 1;
 }
 
-static int r_mark_sUnUz(struct SN_env * z) {
-    if (z->c - 4 <= z->lb || z->p[z->c - 1] != 122) return 0;
-    if (!(find_among_b(z, a_15, 4))) return 0; /* among, line 264 */
+static int r_mark_sUnUz(struct SN_env * z) { /* backwardmode */
+    if (z->c - 4 <= z->lb || z->p[z->c - 1] != 122) return 0; /* among, line 262 */
+    if (!(find_among_b(z, a_15, 4))) return 0;
     return 1;
 }
 
-static int r_mark_lAr(struct SN_env * z) {
-    {   int ret = r_check_vowel_harmony(z);
-        if (ret == 0) return 0; /* call check_vowel_harmony, line 268 */
-        if (ret < 0) return ret;
+static int r_mark_lAr(struct SN_env * z) { /* backwardmode */
+    {   int ret = r_check_vowel_harmony(z); /* call check_vowel_harmony, line 266 */
+        if (ret <= 0) return ret;
     }
-    if (z->c - 2 <= z->lb || z->p[z->c - 1] != 114) return 0;
-    if (!(find_among_b(z, a_16, 2))) return 0; /* among, line 269 */
+    if (z->c - 2 <= z->lb || z->p[z->c - 1] != 114) return 0; /* among, line 267 */
+    if (!(find_among_b(z, a_16, 2))) return 0;
     return 1;
 }
 
-static int r_mark_nUz(struct SN_env * z) {
-    {   int ret = r_check_vowel_harmony(z);
-        if (ret == 0) return 0; /* call check_vowel_harmony, line 273 */
-        if (ret < 0) return ret;
+static int r_mark_nUz(struct SN_env * z) { /* backwardmode */
+    {   int ret = r_check_vowel_harmony(z); /* call check_vowel_harmony, line 271 */
+        if (ret <= 0) return ret;
     }
-    if (z->c - 2 <= z->lb || z->p[z->c - 1] != 122) return 0;
-    if (!(find_among_b(z, a_17, 4))) return 0; /* among, line 274 */
+    if (z->c - 2 <= z->lb || z->p[z->c - 1] != 122) return 0; /* among, line 272 */
+    if (!(find_among_b(z, a_17, 4))) return 0;
     return 1;
 }
 
-static int r_mark_DUr(struct SN_env * z) {
-    {   int ret = r_check_vowel_harmony(z);
-        if (ret == 0) return 0; /* call check_vowel_harmony, line 278 */
-        if (ret < 0) return ret;
+static int r_mark_DUr(struct SN_env * z) { /* backwardmode */
+    {   int ret = r_check_vowel_harmony(z); /* call check_vowel_harmony, line 276 */
+        if (ret <= 0) return ret;
     }
-    if (z->c - 2 <= z->lb || z->p[z->c - 1] != 114) return 0;
-    if (!(find_among_b(z, a_18, 8))) return 0; /* among, line 279 */
+    if (z->c - 2 <= z->lb || z->p[z->c - 1] != 114) return 0; /* among, line 277 */
+    if (!(find_among_b(z, a_18, 8))) return 0;
     return 1;
 }
 
-static int r_mark_cAsInA(struct SN_env * z) {
-    if (z->c - 5 <= z->lb || (z->p[z->c - 1] != 97 && z->p[z->c - 1] != 101)) return 0;
-    if (!(find_among_b(z, a_19, 2))) return 0; /* among, line 283 */
+static int r_mark_cAsInA(struct SN_env * z) { /* backwardmode */
+    if (z->c - 5 <= z->lb || (z->p[z->c - 1] != 97 && z->p[z->c - 1] != 101)) return 0; /* among, line 281 */
+    if (!(find_among_b(z, a_19, 2))) return 0;
     return 1;
 }
 
-static int r_mark_yDU(struct SN_env * z) {
-    {   int ret = r_check_vowel_harmony(z);
-        if (ret == 0) return 0; /* call check_vowel_harmony, line 287 */
-        if (ret < 0) return ret;
+static int r_mark_yDU(struct SN_env * z) { /* backwardmode */
+    {   int ret = r_check_vowel_harmony(z); /* call check_vowel_harmony, line 285 */
+        if (ret <= 0) return ret;
     }
-    if (!(find_among_b(z, a_20, 32))) return 0; /* among, line 288 */
-    {   int ret = r_mark_suffix_with_optional_y_consonant(z);
-        if (ret == 0) return 0; /* call mark_suffix_with_optional_y_consonant, line 292 */
-        if (ret < 0) return ret;
+    if (!(find_among_b(z, a_20, 32))) return 0; /* among, line 286 */
+    {   int ret = r_mark_suffix_with_optional_y_consonant(z); /* call mark_suffix_with_optional_y_consonant, line 290 */
+        if (ret <= 0) return ret;
     }
     return 1;
 }
 
-static int r_mark_ysA(struct SN_env * z) {
-    if (z->c - 1 <= z->lb || z->p[z->c - 1] >> 5 != 3 || !((26658 >> (z->p[z->c - 1] & 0x1f)) & 1)) return 0;
-    if (!(find_among_b(z, a_21, 8))) return 0; /* among, line 297 */
-    {   int ret = r_mark_suffix_with_optional_y_consonant(z);
-        if (ret == 0) return 0; /* call mark_suffix_with_optional_y_consonant, line 298 */
-        if (ret < 0) return ret;
+static int r_mark_ysA(struct SN_env * z) { /* backwardmode */
+    if (z->c - 1 <= z->lb || z->p[z->c - 1] >> 5 != 3 || !((26658 >> (z->p[z->c - 1] & 0x1f)) & 1)) return 0; /* among, line 295 */
+    if (!(find_among_b(z, a_21, 8))) return 0;
+    {   int ret = r_mark_suffix_with_optional_y_consonant(z); /* call mark_suffix_with_optional_y_consonant, line 296 */
+        if (ret <= 0) return ret;
     }
     return 1;
 }
 
-static int r_mark_ymUs_(struct SN_env * z) {
-    {   int ret = r_check_vowel_harmony(z);
-        if (ret == 0) return 0; /* call check_vowel_harmony, line 302 */
-        if (ret < 0) return ret;
+static int r_mark_ymUs_(struct SN_env * z) { /* backwardmode */
+    {   int ret = r_check_vowel_harmony(z); /* call check_vowel_harmony, line 300 */
+        if (ret <= 0) return ret;
     }
-    if (z->c - 3 <= z->lb || z->p[z->c - 1] != 159) return 0;
-    if (!(find_among_b(z, a_22, 4))) return 0; /* among, line 303 */
-    {   int ret = r_mark_suffix_with_optional_y_consonant(z);
-        if (ret == 0) return 0; /* call mark_suffix_with_optional_y_consonant, line 304 */
-        if (ret < 0) return ret;
+    if (z->c - 3 <= z->lb || z->p[z->c - 1] != 159) return 0; /* among, line 301 */
+    if (!(find_among_b(z, a_22, 4))) return 0;
+    {   int ret = r_mark_suffix_with_optional_y_consonant(z); /* call mark_suffix_with_optional_y_consonant, line 302 */
+        if (ret <= 0) return ret;
     }
     return 1;
 }
 
-static int r_mark_yken(struct SN_env * z) {
-    if (!(eq_s_b(z, 3, s_15))) return 0;
-    {   int ret = r_mark_suffix_with_optional_y_consonant(z);
-        if (ret == 0) return 0; /* call mark_suffix_with_optional_y_consonant, line 308 */
-        if (ret < 0) return ret;
+static int r_mark_yken(struct SN_env * z) { /* backwardmode */
+    if (!(eq_s_b(z, 3, s_4))) return 0; /* literal, line 306 */
+    {   int ret = r_mark_suffix_with_optional_y_consonant(z); /* call mark_suffix_with_optional_y_consonant, line 306 */
+        if (ret <= 0) return ret;
     }
     return 1;
 }
 
-static int r_stem_nominal_verb_suffixes(struct SN_env * z) {
-    z->ket = z->c; /* [, line 312 */
-    z->B[0] = 1; /* set continue_stemming_noun_suffixes, line 313 */
-    {   int m1 = z->l - z->c; (void)m1; /* or, line 315 */
-        {   int m2 = z->l - z->c; (void)m2; /* or, line 314 */
-            {   int ret = r_mark_ymUs_(z);
-                if (ret == 0) goto lab3; /* call mark_ymUs_, line 314 */
+static int r_stem_nominal_verb_suffixes(struct SN_env * z) { /* backwardmode */
+    z->ket = z->c; /* [, line 310 */
+    z->B[0] = 1; /* set continue_stemming_noun_suffixes, line 311 */
+    {   int m1 = z->l - z->c; (void)m1; /* or, line 313 */
+        {   int m2 = z->l - z->c; (void)m2; /* or, line 312 */
+            {   int ret = r_mark_ymUs_(z); /* call mark_ymUs_, line 312 */
+                if (ret == 0) goto lab3;
                 if (ret < 0) return ret;
             }
             goto lab2;
         lab3:
             z->c = z->l - m2;
-            {   int ret = r_mark_yDU(z);
-                if (ret == 0) goto lab4; /* call mark_yDU, line 314 */
+            {   int ret = r_mark_yDU(z); /* call mark_yDU, line 312 */
+                if (ret == 0) goto lab4;
                 if (ret < 0) return ret;
             }
             goto lab2;
         lab4:
             z->c = z->l - m2;
-            {   int ret = r_mark_ysA(z);
-                if (ret == 0) goto lab5; /* call mark_ysA, line 314 */
+            {   int ret = r_mark_ysA(z); /* call mark_ysA, line 312 */
+                if (ret == 0) goto lab5;
                 if (ret < 0) return ret;
             }
             goto lab2;
         lab5:
             z->c = z->l - m2;
-            {   int ret = r_mark_yken(z);
-                if (ret == 0) goto lab1; /* call mark_yken, line 314 */
+            {   int ret = r_mark_yken(z); /* call mark_yken, line 312 */
+                if (ret == 0) goto lab1;
                 if (ret < 0) return ret;
             }
         }
